package com.sratest.client;

import java.util.Properties;

import javax.naming.Context;
import javax.naming.InitialContext;

import com.sratest.service.TestObjectService;
import com.sratest.service.TestProxyService;

public class TestClient {
	
	public static void main(String ar[]) throws Exception {

		Context context = null;
		try {
	        Properties props = new Properties();
			
	        props.setProperty( "jboss.naming.client.connect.options.org.xnio.Options.SASL_POLICY_NOANONYMOUS", "true" );
	        props.setProperty( "jboss.naming.client.connect.options.org.xnio.Options.SASL_DISALLOWED_MECHANISMS", "JBOSS-LOCAL-USER" );
	        props.setProperty( "jboss.naming.client.connect.options.org.xnio.Options.SASL_POLICY_NOPLAINTEXT", "false" );

	        props.setProperty( "java.naming.factory.initial", "org.jboss.naming.remote.client.InitialContextFactory" );
	        props.setProperty( "jboss.naming.client.ejb.context", "true" );
	        props.setProperty( "java.naming.provider.url", "remote://localhost:4447" );
	        props.setProperty( "java.naming.factory.url.pkgs", "org.jboss.ejb.client.naming" );
	        props.setProperty( "java.naming.security.principal",   "testuser" );
	        props.setProperty( "java.naming.security.credentials", "testpassword" );

	        props.setProperty( "remote.connectionprovider.create.options.org.xnio.Options.SSL_ENABLED", "false" );
	        props.setProperty( "remote.connections", "default" );
	        props.setProperty( "remote.connection.default.host", "localhost" );
	        props.setProperty( "remote.connection.default.port", "4447" );

			context = new InitialContext( props );	
	        System.out.println("\n\tGot initial Context: "+context);		
		}
		catch( Exception e ) {
                e.printStackTrace();
		}

		// sending object message with ordinary class instance
		TestObjectService objectService = ( TestObjectService )context.lookup( "jms-proxy-test/jms-proxy-test-ejb//com.sratest.service.TestObjectServiceImpl!com.sratest.service.TestObjectService" );
        objectService.testMethod();

		// sending object message with proxy instance
		TestProxyService proxyService = ( TestProxyService )context.lookup( "jms-proxy-test/jms-proxy-test-ejb//com.sratest.service.TestProxyServiceImpl!com.sratest.service.TestProxyService" );
        proxyService.testMethod();
	}
}
