package com.sratest.mdb;

import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.ObjectMessage;

import com.sratest.payload.MyObjectMessage;

@MessageDriven(messageListenerInterface=MessageListener.class, activationConfig =
{
    @ActivationConfigProperty( propertyName = "destinationType",         propertyValue = "javax.jms.Queue"),
    @ActivationConfigProperty( propertyName = "destination",             propertyValue = "queue/test" ),
    @ActivationConfigProperty( propertyName = "maxSession",              propertyValue = "1" ),
    @ActivationConfigProperty( propertyName = "subscriptionDurability",  propertyValue = "Durable")
} )
public class TestMDB implements MessageListener {

	@Override
	public void onMessage( Message inMessage ) {
		if( !( inMessage instanceof ObjectMessage ) ) {
			throw new RuntimeException( "unexpected message type " + inMessage.getClass().getName() );
		}

		Object messageObject;
		try {
			messageObject = ( ( ObjectMessage )inMessage ).getObject();
		} catch( JMSException e) {
			throw new RuntimeException( "Failed to get message object", e );
		}

		if( messageObject == null ) {
			throw new RuntimeException( "message object is null" );
		}
		if( !( messageObject instanceof MyObjectMessage ) ) {
			throw new RuntimeException( "unexpected message object type " + messageObject.getClass().getName() );
		}
		System.err.println( "XXX MyObjectMessage.stringValue = " + ( ( MyObjectMessage )messageObject ).getStringValue() );
		System.err.println( "XXX MyObjectMessage.longValue   = " + ( ( MyObjectMessage )messageObject ).getLongValue() );
		System.err.println( "XXX MyObjectMessage.intValue    = " + ( ( MyObjectMessage )messageObject ).getIntValue() );
	}
}
