package com.sratest.service;

import javax.ejb.Remote;
import javax.ejb.Stateless;
import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.MessageProducer;
import javax.jms.ObjectMessage;
import javax.jms.Queue;
import javax.jms.Session;
import javax.naming.Context;
import javax.naming.InitialContext;

import com.sratest.payload.MyObjectMessageImpl;

@Stateless( name="com.sratest.service.TestObjectServiceImpl" )
@Remote( TestObjectService.class )
public class TestObjectServiceImpl implements TestObjectService {

	@Override
	public void testMethod() {
		Context           ic         = null;
		ConnectionFactory cf         = null;
		Connection        connection = null;
		try {
			ic = new InitialContext();
			cf = (ConnectionFactory)ic.lookup("/ConnectionFactory");
			Queue queue = ( Queue )ic.lookup( "queue/test" );

			connection = cf.createConnection();
			Session session = connection.createSession( false, Session.AUTO_ACKNOWLEDGE );
			MessageProducer publisher = session.createProducer( queue );

			connection.start();

			ObjectMessage message = session.createObjectMessage( new MyObjectMessageImpl( "HUHU", 4711L, 42 ) );

			publisher.send( message );
		} catch( Exception e ) {
			e.printStackTrace();
		} finally {
			if( connection != null ) {
				try {
					connection.close();
				} catch( JMSException e ) {                   
					e.printStackTrace();
				}
			} 
		}
	}
}
