package com.sratest.service;

import java.lang.reflect.Proxy;
import java.util.HashMap;

import javax.ejb.Remote;
import javax.ejb.Stateless;
import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.MessageProducer;
import javax.jms.ObjectMessage;
import javax.jms.Queue;
import javax.jms.Session;
import javax.naming.Context;
import javax.naming.InitialContext;

import com.sratest.payload.MyObjectMessage;
import com.sratest.proxy.GenericDTOImpl;

@Stateless( name="com.sratest.service.TestProxyServiceImpl" )
@Remote( TestProxyService.class )
public class TestProxyServiceImpl implements TestProxyService {

	@Override
	public void testMethod() {
		Context           ic         = null;
		ConnectionFactory cf         = null;
		Connection        connection = null;
		try {
			ic = new InitialContext();
			cf = (ConnectionFactory)ic.lookup("/ConnectionFactory");
			Queue queue = ( Queue )ic.lookup( "queue/test" );

			connection = cf.createConnection();
			Session session = connection.createSession( false, Session.AUTO_ACKNOWLEDGE );
			MessageProducer publisher = session.createProducer( queue );

			connection.start();

			HashMap <String,Object> values          = new HashMap<String, Object>();
			MyObjectMessage         dtoInstance     = ( MyObjectMessage )Proxy.newProxyInstance( MyObjectMessage.class.getClassLoader(),
																								 new Class[]{ MyObjectMessage.class },
																								 new GenericDTOImpl( values ) );
			values.put( MyObjectMessage.STRING_VALUE_FIELD, "HUHU" );
			values.put( MyObjectMessage.LONG_VALUE_FIELD,   4711L );
			values.put( MyObjectMessage.INT_VALUE_FIELD,    42 );

			ObjectMessage message = session.createObjectMessage( dtoInstance );

			publisher.send( message );
		} catch( Exception e ) {
			e.printStackTrace();
		} finally {
			if( connection != null ) {
				try {
					connection.close();
				} catch( JMSException e ) {                   
					e.printStackTrace();
				}
			} 
		}
	}
}
